package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.Room;
import org.vtokarev.domain.RoomClass;
import org.vtokarev.domain.User;
import org.vtokarev.service.BookingService;
import org.vtokarev.service.RoomClassService;
import org.vtokarev.service.RoomService;
import org.vtokarev.tuples.Pair;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.lang.invoke.MethodHandles;
import java.time.LocalDate;
import java.time.format.DateTimeParseException;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * The {@code BookRoomGuestServlet} class implements {@code doGet} method that processes GET {@code bookRoomGuest} requests generated by users with GUEST role.
 * In the {@code doGet} method, it collects the necessary data from the GUEST request and forwards them to {@code bookRoomGuest.jsp} view for further processing.
 * <p>
 * In the {@code doPost} method implementation, it collects the necessary data from the GUEST request and create {@link org.vtokarev.domain.Booking}.
 * If the booking is successful it forwards the control to {@code bookingList},
 * otherwise set {@code errorMessage} as a parameter and forward the control to {@code searchRoom} to collect booking parameters again for the next booking attempt.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/bookRoomGuest", name = "bookRoomGuestServlet")
public class BookRoomGuestServlet extends HttpServlet {

    private final static Logger LOGGER = LogManager.getLogger(MethodHandles.lookup().lookupClass());

    private RoomClassService roomClassService;

    private RoomService roomService;
    private BookingService bookingService;


    @Override
    public void init(ServletConfig config) throws ServletException {
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
        roomClassService = (RoomClassService) config.getServletContext().getAttribute("app/RoomClassService");
        bookingService = (BookingService) config.getServletContext().getAttribute("app/BookingService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        if (req.getParameter("roomId") == null ||
                req.getParameter("checkin") == null ||
                req.getParameter("checkout") == null) {
            resp.sendRedirect("searchRoom");
        }

        Optional<Room> room = roomService.getRoomById(Long.parseLong(req.getParameter("roomId")));

        if (room.isEmpty()) {
            resp.sendRedirect("searchRoom");
        }

        room.ifPresent(r -> {
            Optional<RoomClass> roomClass = roomClassService.get(r.getRoomClassId());
            roomClass.ifPresent(rc -> req.setAttribute("roomClassName", rc.getName()));
            LocalDate checkin = LocalDate.parse(req.getParameter("checkin"));
            LocalDate checkout = LocalDate.parse(req.getParameter("checkout"));
            req.setAttribute("room", room.get());
            req.setAttribute("checkin", checkin);
            req.setAttribute("checkout", checkout);
            req.setAttribute("images", roomService.getImagePaths(room.get()).stream().map(Pair::getA).collect(Collectors.toList()));
        });
        req.getRequestDispatcher("/WEB-INF/jsp/bookRoomGuest.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        if (req.getParameter("checkin") == null ||
                req.getParameter("checkout") == null ||
                req.getParameter("roomId") == null ||
                req.getParameter("price") == null) {
            resp.sendRedirect("searchRoom");
            return;
        }

        long userId = 0;
        LocalDate checkin = null;
        LocalDate checkout = null;
        long roomId = 0;
        double price = 0d;

        try {
            userId = ((User) req.getSession().getAttribute("user")).getId();
            checkin = LocalDate.parse(req.getParameter("checkin"));
            checkout = LocalDate.parse(req.getParameter("checkout"));
            roomId = Long.parseLong(req.getParameter("roomId"));
            price = Double.parseDouble(req.getParameter("price"));
        } catch (NumberFormatException | DateTimeParseException e) {
            LOGGER.warn("Failed to parse request param doPost");
            resp.sendRedirect("searchRoom");
        }

        String errorMessage = bookingService.bookRoom(userId, roomId, price, checkin, checkout, null, null);

        if (errorMessage == null) {
            resp.sendRedirect("bookingList");
        } else {
            resp.sendRedirect("searchRoom?errorMessage=" + errorMessage);
        }
    }
}
